/*
 *
 *  * Copyright (C) 2014 Numatica Corporation.
 *  * All Rights Reserved.
 *  *
 *  * NOTICE:  All information contained herein is, and remains
 *  * the property of Numatica Corporation and its suppliers,
 *  * if any.  The intellectual and technical concepts contained
 *  * herein are proprietary to Numatica Corporation
 *  * and its suppliers and may be covered by U.S. and Foreign Patents,
 *  * patents in process, and are protected by trade secret or copyright law.
 *  * Dissemination of this information or reproduction of this material
 *  * is strictly forbidden unless prior written permission is obtained
 *  * from Numatica Corporation.
 *
 */

package com.numatica.insightmagic;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.jdbc.support.incrementer.PostgreSQLSequenceMaxValueIncrementer;

import javax.sql.DataSource;

/**
 * Created by Jacek on 8/6/2014.
 */
@Configuration
public class DBConfiguration {

    @Value("${sessionSequenceName:session_seq}")
    private String sessionSequenceName;

    @Value("${userActionSequenceName:userAction_seq}")
    private String userActionSequenceName;

    @Autowired
    private DataSource dataSource;

    @Bean(name = "sessionSequence")
    PostgreSQLSequenceMaxValueIncrementer getSessionSequence() {
        PostgreSQLSequenceMaxValueIncrementer sessionSequence = new PostgreSQLSequenceMaxValueIncrementer(dataSource, sessionSequenceName);
        return sessionSequence;
    }

    @Bean(name = "userActionSequence")
    PostgreSQLSequenceMaxValueIncrementer getUserActionSequence() {
        PostgreSQLSequenceMaxValueIncrementer userActionSequence = new PostgreSQLSequenceMaxValueIncrementer(dataSource, userActionSequenceName);
        return userActionSequence;
    }



}
