/*
 *
 *  * Copyright (C) 2014 Numatica Corporation.
 *  * All Rights Reserved.
 *  *
 *  * NOTICE:  All information contained herein is, and remains
 *  * the property of Numatica Corporation and its suppliers,
 *  * if any.  The intellectual and technical concepts contained
 *  * herein are proprietary to Numatica Corporation
 *  * and its suppliers and may be covered by U.S. and Foreign Patents,
 *  * patents in process, and are protected by trade secret or copyright law.
 *  * Dissemination of this information or reproduction of this material
 *  * is strictly forbidden unless prior written permission is obtained
 *  * from Numatica Corporation.
 *
 */

package com.numatica.insightmagic;

import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * Created by Jacek on 7/28/2014.
 */
@Component
@ConfigurationProperties(prefix="datagrid")
public class DataGridSettings {

    private boolean managementCenterEnabled;
    private String managementCenterURL;
    private int applicationDelay; // 4000
    private boolean multicast; //false
    private List<String> tcpIpMembers;
    private List<String> interfaces;

    public boolean isManagementCenterEnabled() {
        return managementCenterEnabled;
    }

    public void setManagementCenterEnabled(boolean managementCenterEnabled) {
        this.managementCenterEnabled = managementCenterEnabled;
    }

    public String getManagementCenterURL() {
        return managementCenterURL;
    }

    public void setManagementCenterURL(String managementCenterURL) {
        this.managementCenterURL = managementCenterURL;
    }

    public int getApplicationDelay() {
        return applicationDelay;
    }

    public void setApplicationDelay(int applicationDelay) {
        this.applicationDelay = applicationDelay;
    }

    public boolean isMulticast() {
        return multicast;
    }

    public void setMulticast(boolean multicast) {
        this.multicast = multicast;
    }

    public List<String> getTcpIpMembers() {
        return tcpIpMembers;
    }

    public void setTcpIpMembers(List<String> tcpIpMembers) {
        this.tcpIpMembers = tcpIpMembers;
    }

    public List<String> getInterfaces() {
        return interfaces;
    }

    public void setInterfaces(List<String> interfaces) {
        this.interfaces = interfaces;
    }
}
