/*
 *
 *  * Copyright (C) 2014 Numatica Corporation.
 *  * All Rights Reserved.
 *  *
 *  * NOTICE:  All information contained herein is, and remains
 *  * the property of Numatica Corporation and its suppliers,
 *  * if any.  The intellectual and technical concepts contained
 *  * herein are proprietary to Numatica Corporation
 *  * and its suppliers and may be covered by U.S. and Foreign Patents,
 *  * patents in process, and are protected by trade secret or copyright law.
 *  * Dissemination of this information or reproduction of this material
 *  * is strictly forbidden unless prior written permission is obtained
 *  * from Numatica Corporation.
 *
 */

package com.numatica.insightmagic;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.context.embedded.EmbeddedServletContainerFactory;
import org.springframework.boot.context.embedded.jetty.JettyEmbeddedServletContainerFactory;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import java.util.concurrent.TimeUnit;

/**
 * Created by Jacek on 7/29/2014.
 */
@Configuration
public class JettyConfiguration {

    @Value("${port:8080}")
    private int httpPort;

    @Value("${sessionTimeout:1}")
    private int sessionTimeout;

     /* @Bean
    public EmbeddedServletContainerFactory embeddedServletContainerFactory() throws Exception {

        return new JettyEmbeddedServletContainerFactory() {

            @Override
            protected JettyEmbeddedServletContainer getJettyEmbeddedServletContainer(
                    Server server) {

                HttpConfiguration httpConfig = new HttpConfiguration();
                ServerConnector httpConnector = new ServerConnector(server, new HttpConnectionFactory(httpConfig));
                httpConnector.setPort(httpPort);
                server.setConnectors(new Connector[]{httpConnector});
                return super.getJettyEmbeddedServletContainer(server);
            }
        };
    }*/

    @Bean
    public EmbeddedServletContainerFactory servletContainer() {
        JettyEmbeddedServletContainerFactory factory = new JettyEmbeddedServletContainerFactory();
        factory.setPort(httpPort);
        factory.setSessionTimeout(sessionTimeout, TimeUnit.MINUTES);
        return factory;
    }


}
