/*
 *
 *  * Copyright (C) 2014 Numatica Corporation.
 *  * All Rights Reserved.
 *  *
 *  * NOTICE:  All information contained herein is, and remains
 *  * the property of Numatica Corporation and its suppliers,
 *  * if any.  The intellectual and technical concepts contained
 *  * herein are proprietary to Numatica Corporation
 *  * and its suppliers and may be covered by U.S. and Foreign Patents,
 *  * patents in process, and are protected by trade secret or copyright law.
 *  * Dissemination of this information or reproduction of this material
 *  * is strictly forbidden unless prior written permission is obtained
 *  * from Numatica Corporation.
 *
 */

package com.numatica.insightmagic.external;

/**
 * Created by Jacek on 3/28/2014.
 */
public enum ApiReturnCode {

    SUCCESS(0, "SUCCESS"),
    INVALID_ARGUMENT(1, "Invalid Argument"),
    INVALID_API_KEY(2, "Invalid API Token"),
    INVALID_SESSION(3, "Invalid session token or session expired"),
    INVALID_PERMISSION(4, "Invalid or insufficient permission"),

    INVALID_USER(10, "Invalid user id"),
    INVALID_PASSWORD(11, "Invalid password"),
    USER_DOES_NOT_EXIST(12, "User does not exist"),
    USER_EXISTS(13, "User already exists"),
    SESSION_EXISTS(14, "Session already exists"),

    DUPLICATE_BUSINESS_KEY(100, "Duplicate business key"),
    DUPLICATE_MAP_KEY(900, "Duplicate map key"),

    INVALID_STATUS_TOKEN(951, "Status token is invalid or expired"),
    INVALID_REQUEST_STATUS_TOKEN(952, "statusToken parameter is not supported in this request"),
    INVALID_REQUEST_SERVICE_ID(953, "serviceId parameter is not supported in this request"),

    INTERNAL_ERROR(999, "Internal error"),
    NOT_IMPLEMENTED(1000, "Service not implemented");

    private int code;
    private String message;

    private ApiReturnCode(final int code, final String message) {
        this.code = code;
        this.message = message;
    }

    public int getCode() {
        return code;
    }

    public String getMessage() {
        return message;
    }
}
