/*
 *
 *  * Copyright (C) 2014 Numatica Corporation.
 *  * All Rights Reserved.
 *  *
 *  * NOTICE:  All information contained herein is, and remains
 *  * the property of Numatica Corporation and its suppliers,
 *  * if any.  The intellectual and technical concepts contained
 *  * herein are proprietary to Numatica Corporation
 *  * and its suppliers and may be covered by U.S. and Foreign Patents,
 *  * patents in process, and are protected by trade secret or copyright law.
 *  * Dissemination of this information or reproduction of this material
 *  * is strictly forbidden unless prior written permission is obtained
 *  * from Numatica Corporation.
 *
 */

package com.numatica.insightmagic.external;

import java.io.Serializable;

/**
 * Generic response object for RESTful API calls
 *
 * @since 6/4/14
 */
public class RestResponse implements Serializable {
    private static final long serialVersionUID = -1L;

    private ResponseStatus status;

    public RestResponse() {}

    public RestResponse(final ResponseStatus status) {
        this.status = status;
    }

    public RestResponse(final ApiReturnCode code) {
        this.status = new ResponseStatus(code);
    }

    public ResponseStatus getStatus() {
        return status;
    }

    public void setStatus(final ResponseStatus status) {
        this.status = status;
    }
}
