/*
 *
 *  * Copyright (C) 2014 Numatica Corporation.
 *  * All Rights Reserved.
 *  *
 *  * NOTICE:  All information contained herein is, and remains
 *  * the property of Numatica Corporation and its suppliers,
 *  * if any.  The intellectual and technical concepts contained
 *  * herein are proprietary to Numatica Corporation
 *  * and its suppliers and may be covered by U.S. and Foreign Patents,
 *  * patents in process, and are protected by trade secret or copyright law.
 *  * Dissemination of this information or reproduction of this material
 *  * is strictly forbidden unless prior written permission is obtained
 *  * from Numatica Corporation.
 *
 */
package com.numatica.insightmagic.geolocation.service;

import com.numatica.insightmagic.authentication.AuthenticatedCall;
import com.numatica.insightmagic.external.ApiReturnCode;
import com.numatica.insightmagic.external.ResponseStatus;
import com.numatica.insightmagic.external.RestResponse;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

/**
 * Created with IntelliJ IDEA.
 * User: Jacek
 * Date: 10/3/14
 * Time: 1:38 PM
 * To change this template use File | Settings | File Templates.
 */
@RestController
@RequestMapping(value="/geoservice")
public class GeoServiceController {

    protected final Logger log = LoggerFactory.getLogger(GeoServiceController.class);

       @Autowired
       private GeoService geoService;


       @RequestMapping(value = "ingestData", method = {RequestMethod.POST})
       @ResponseBody
       @AuthenticatedCall(userSessionRequired = false)
       public RestResponse ingestData(Long apiKey, Long sessionKey, String fileName) {

           ResponseStatus status = null;

           try {
               geoService.loadExternalData(fileName);
               return new RestResponse(new ResponseStatus(ApiReturnCode.SUCCESS));
           } catch (Exception ex) {
               log.error(ex.getLocalizedMessage());
               return new RestResponse(new ResponseStatus(ApiReturnCode.INTERNAL_ERROR));
           }
       }
}
