/*
 *
 *  * Copyright (C) 2014 Numatica Corporation.
 *  * All Rights Reserved.
 *  *
 *  * NOTICE:  All information contained herein is, and remains
 *  * the property of Numatica Corporation and its suppliers,
 *  * if any.  The intellectual and technical concepts contained
 *  * herein are proprietary to Numatica Corporation
 *  * and its suppliers and may be covered by U.S. and Foreign Patents,
 *  * patents in process, and are protected by trade secret or copyright law.
 *  * Dissemination of this information or reproduction of this material
 *  * is strictly forbidden unless prior written permission is obtained
 *  * from Numatica Corporation.
 *
 */

package com.numatica.insightmagic.service;

import com.hazelcast.core.HazelcastInstance;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * Created by Jacek on 6/13/2014.
 */
@Service
public class HazelcastBasedService {

    @Autowired
    protected HazelcastInstance hz;

    public Long getLocalMapSize(String mapName) {
        return hz.getMap(mapName).getLocalMapStats().getOwnedEntryCount();
    }

    public int getTotalMapSize(String mapName) {
        return hz.getMap(mapName).size();
    }

    public String printLocalMapSize(String mapName) {
        return String.format("Map [%s] size: [%d]", mapName, getLocalMapSize(mapName));

    }

    public String printTotalMapSize(String mapName) {
        return String.format("Map [%s] size: [%d]", mapName, getTotalMapSize(mapName));
    }
}
