/*
 *
 *  * Copyright (C) 2014 Numatica Corporation.
 *  * All Rights Reserved.
 *  *
 *  * NOTICE:  All information contained herein is, and remains
 *  * the property of Numatica Corporation and its suppliers,
 *  * if any.  The intellectual and technical concepts contained
 *  * herein are proprietary to Numatica Corporation
 *  * and its suppliers and may be covered by U.S. and Foreign Patents,
 *  * patents in process, and are protected by trade secret or copyright law.
 *  * Dissemination of this information or reproduction of this material
 *  * is strictly forbidden unless prior written permission is obtained
 *  * from Numatica Corporation.
 *
 */
package com.numatica.insightmagic;

import com.hazelcast.client.HazelcastClient;
import com.hazelcast.client.config.ClientConfig;
import com.hazelcast.core.HazelcastInstance;
import com.hazelcast.core.IMap;
import com.hazelcast.query.SqlPredicate;
import com.numatica.insightmagic.interaction.UserAction;

import java.util.Collection;
import java.util.Map;
import java.util.concurrent.TimeUnit;
import java.util.stream.Collectors;

/**
 * Created with IntelliJ IDEA.
 * User: Jacek
 * Date: 10/12/14
 * Time: 7:08 PM
 * To change this template use File | Settings | File Templates.
 */
public class AtRestAnalytics {

    public static void main(String[] args) {

        ClientConfig clientConfig = new ClientConfig();
        HazelcastInstance client = HazelcastClient.newHazelcastClient(clientConfig);
        IMap<Long, UserAction> userActionHistory = client.getMap(HazelcastConfiguration.USER_ACTION_HISTORY_MAP);
        try {
            while (true) {
                System.out.println("User Action History map size " + userActionHistory.size());

                //Profiler profiler = new Profiler("Get break-ins ");
                //profiler.start("Values");

                Collection<UserAction> actions = userActionHistory.values(new SqlPredicate("timestamp > " + (System.nanoTime() - TimeUnit.MINUTES.toNanos(30))));
                Map<String, Long> byCountry = actions.stream()
                        .collect(Collectors.groupingBy(UserAction::getCountryCode, Collectors.counting()));

                System.out.println(actions.size() + " attempts in the last 30 minutes ");
                for (String countryCode : byCountry.keySet()) {
                    System.out.println("Country " + countryCode + " Number of actions: " + byCountry.get(countryCode));
                }
                Thread.sleep(5000);
            }
        } catch (Throwable t) {
            client.shutdown();
        }
    }
}
