/*
 * Numatica Corporation ("COMPANY") CONFIDENTIAL
 *
 * Copyright (c) 2012. All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains the property of COMPANY.
 * The intellectual and technical concepts contained herein are proprietary to COMPANY and may be covered by U.S.
 * and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material is strictly forbidden unless prior written
 * permission is obtained from COMPANY.  Access to the source code contained herein is hereby forbidden to anyone
 * except current COMPANY employees, managers or contractors who have executed Confidentiality and Non-disclosure
 * agreements explicitly covering such access.
 *
 * The copyright notice above does not evidence any actual or intended publication or disclosure  of  this source code,
 * which includes information that is confidential and/or proprietary, and is a trade secret, of  COMPANY.
 * ANY REPRODUCTION, MODIFICATION, DISTRIBUTION, PUBLIC  PERFORMANCE, OR PUBLIC DISPLAY OF OR THROUGH USE  OF THIS
 * SOURCE CODE WITHOUT THE EXPRESS WRITTEN CONSENT OF COMPANY IS STRICTLY PROHIBITED, AND IN VIOLATION OF APPLICABLE
 * LAWS AND INTERNATIONAL TREATIES.  THE RECEIPT OR POSSESSION OF  THIS SOURCE CODE AND/OR RELATED INFORMATION DOES
 * NOT CONVEY OR IMPLY ANY RIGHTS TO REPRODUCE, DISCLOSE OR DISTRIBUTE ITS CONTENTS, OR TO MANUFACTURE, USE,
 * OR SELL ANYTHING THAT IT  MAY DESCRIBE, IN WHOLE OR IN PART.
 */
package com.numatica.insightmagic;

import com.numatica.insightmagic.external.ApiReturnCode;
import com.numatica.insightmagic.external.RestResponse;
import com.numatica.insightmagic.session.external.SessionResponse;
import com.numatica.insightmagic.user.external.UserAccountResponse;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.http.converter.FormHttpMessageConverter;
import org.springframework.http.converter.StringHttpMessageConverter;
import org.springframework.http.converter.json.MappingJackson2HttpMessageConverter;
import org.springframework.util.LinkedMultiValueMap;
import org.springframework.util.MultiValueMap;
import org.springframework.web.client.RestTemplate;

import java.util.Random;

/**
 * Created with IntelliJ IDEA.
 * User: Jacek
 * Date: 10/6/14
 * Time: 1:58 PM
 * To change this template use File | Settings | File Templates.
 */
public class TrafficInfoGenerator {

    public static final Long API_KEY = 19141918193919451L;
    public static final String SUPER_USER = "fm_superuser@numatica.com";
    public static final String SUPER_USER_PASSWORD = "password";
    private static final String url = "http://localhost:8080";
    //private static final String url = "http://72.52.171.124:8080";
    private static final String createAccountUrl = "/account/createUserAccount";
    private static final String registerUserActionsUrl = "/useraction/registerUserAction";
    private RestTemplate restTemplate = new RestTemplate();
    private String loginUrl = "/session/login";
    private String logoutUrl = "/session/logout";

    public static void main(String[] args) {

        TrafficInfoGenerator tig = new TrafficInfoGenerator();
        tig.initialize();
        tig.registerUserActions();
        tig.logout(sessionId);
    }

    public void initialize() {
        restTemplate.getMessageConverters().add(new MappingJackson2HttpMessageConverter());
        restTemplate.getMessageConverters().add(new StringHttpMessageConverter());
        restTemplate.getMessageConverters().add(new FormHttpMessageConverter());
    }

    public void registerUserActions() {

        Runnable generateUserActions = () -> {
            for (int i = 0; i < 100000; i++) {
                registerUserAction(generateSessionId(), generateActionCode(), generateIpAddress());
                try {
                    Thread.sleep(100);
                } catch (InterruptedException ex) {}
            }
        };

        Runnable generateLoginActions = () -> {
            for (int i = 0; i < 10000; i ++) {
                registerUserAction(null, 1, generateIpAddress());
                try {
                    Thread.sleep(1000);
                } catch (InterruptedException ex) {}
            }
        };

        generateUserActions.run();
        generateLoginActions.run();

    }

    private Integer generateActionCode() {
            Random r = new Random();
            return r.nextInt(10);
        }

    private String generateIpAddress() {
        Random r = new Random();
        return r.nextInt(80) + "." + r.nextInt(255) + "." + r.nextInt(255) + "." + r.nextInt(255);
    }

    private long generateSessionId() {
        Random r = new Random();
        return r.nextInt(10);
    }

    public void registerUserAction(Long userSessionId, Integer actionCode, String ipAddress) {
        MultiValueMap<String, String> map = new LinkedMultiValueMap<String, String>();
        HttpHeaders headers = new HttpHeaders();
        headers.setContentType(MediaType.APPLICATION_FORM_URLENCODED);
        map.add("apiKey", String.valueOf(API_KEY));
        if (userSessionId != null) {
            map.add("sessionId", Long.toString(userSessionId));
        }
        map.add("actionCode", Integer.toString(actionCode));
        map.add("ipAddress", ipAddress);
        map.add("timestamp", Long.toString(System.nanoTime()));

        HttpEntity<MultiValueMap<String, String>> request = new HttpEntity<MultiValueMap<String, String>>(map, headers);
        long t1 = System.nanoTime();
        RestResponse response = restTemplate.postForObject(url + registerUserActionsUrl, request, RestResponse.class);
        System.out.println("Time = " + (System.nanoTime() - t1) / 1000000 + " ms");
        if (response != null) {
            if (response.getStatus().getStatusCode() == ApiReturnCode.SUCCESS.getCode()) {
                //
            } else {
                System.out.println("registerUserAction: " + response.getStatus().getMessage());
            }
        } else {
            System.out.println("RegisterUserAction : Empty response");
        }

    }

    public Long login(Long apiKey, String userEmail, String password) {
        MultiValueMap<String, String> map = new LinkedMultiValueMap<String, String>();
        HttpHeaders headers = new HttpHeaders();
        headers.setContentType(MediaType.APPLICATION_FORM_URLENCODED);
        map.add("apiKey", String.valueOf(apiKey));
        map.add("emailAddress", userEmail);
        map.add("encryptedPassword", password);
        HttpEntity<MultiValueMap<String, String>> request = new HttpEntity<MultiValueMap<String, String>>(map, headers);
        long timestamp = System.nanoTime();
        SessionResponse response = restTemplate.postForObject(url + loginUrl, request, SessionResponse.class);
        System.out.println("Time = " + (System.nanoTime() - timestamp) / 1000000 + " ms");
        if (response != null) {
            if (response.getStatus().getStatusCode() == com.numatica.insightmagic.external.ApiReturnCode.SUCCESS.getCode()) {
                return response.getSessionKey();
            } else {
                System.out.println("Login: " + response.getStatus().getMessage());
            }
        } else {
            System.out.println("Login: Empty response");
        }
        return null;
    }

    public void logout(Long sessionId) {
        MultiValueMap<String, String> map = new LinkedMultiValueMap<String, String>();
        HttpHeaders headers = new HttpHeaders();
        headers.setContentType(MediaType.APPLICATION_FORM_URLENCODED);
        map.add("apiKey", String.valueOf(API_KEY));
        map.add("sessionKey", String.valueOf(sessionId));

        HttpEntity<MultiValueMap<String, String>> request = new HttpEntity<MultiValueMap<String, String>>(map, headers);
        long t1 = System.nanoTime();
        SessionResponse response = restTemplate.postForObject(url + logoutUrl, request, com.numatica.insightmagic.session.external.SessionResponse.class);
        System.out.println("Time = " + (System.nanoTime() - t1) / 1000000 + " ms");
        if (response != null) {
            if (response.getStatus().getStatusCode() == com.numatica.insightmagic.external.ApiReturnCode.SUCCESS.getCode()) {
                System.out.println("Success");
            } else {
                System.out.println("Logout: " + response.getStatus().getMessage());
            }
        } else {
            System.out.println("Logout: Empty response");
        }
    }

}
